//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// Gif.cpp: implementation of the CGif class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>


#include "blueeye.h"
#include "Gif.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGif::CGif()
{

}

CGif::~CGif()
{

}


int CGif::_color_load_depth(int depth);


////////////////////////////////////////////////////////////////////////////
// Smaze tabulku

void CGif::clear_table(void)
{
	empty_string = cc + 2;
	curr_bit_size = bit_size + 1;
	bit_overflow = 0;
}


////////////////////////////////////////////////////////////////////////////
// Da kod

void CGif::get_code(void)
{
	if(bit_pos + curr_bit_size > 8) {
		if(data_pos >= data_len) { data_len = f_getc(); data_pos = 0; }
		entire = (f_getc() << 8) + entire;
		data_pos ++;
	}
	if(bit_pos + curr_bit_size > 16) {
		if(data_pos >= data_len) { data_len = f_getc(); data_pos = 0; }
		entire = (f_getc() << 16) + entire;
		data_pos ++;
	}
	code = (entire >> bit_pos) & ((1 << curr_bit_size) - 1);
	if(bit_pos + curr_bit_size > 8)
		entire >>= 8;
	if(bit_pos + curr_bit_size > 16)
		entire >>= 8;
	bit_pos = (bit_pos + curr_bit_size) % 8;
	if(bit_pos == 0) {
		if(data_pos >= data_len) { data_len = f_getc(); data_pos = 0; }
		entire = f_getc();
		data_pos ++;
	}
}


////////////////////////////////////////////////////////////////////////////
// nacte string

void CGif::get_string(int num)
{
	if(num < cc)
	{
		string_length = 1;
		string[0] = str[num].newch;
	}
	else
	{
		i = str[num].length;
		string_length = i;
		while(i > 0)
		{
			i --;
			string[i] = str[num].newch;
			num = str[num].base;
		}
		/* if(num != -1) **-{[ERROR]}-** */
	}
}


////////////////////////////////////////////////////////////////////////////
// zpracuje tring

void CGif::output_string(void)
{
	for(i = 0; i < string_length; i ++)
	{
//		bmp[x*y*3] = 200; //pal[string[i]].b;
		*px++ = pal[string[i]].b;
//		bmp[x*y*3+1] = pal[string[i]].r;
//		bmp[x*y*3+2] = pal[string[i]].g;
		x ++;
		*px++ = pal[string[i]].g;
		*px++ = pal[string[i]].r;
//		px++;
		if(x >= image_x + image_w)
		{
			x = image_x;
			y += interlace;
			if(interlace)
			{
				if(y >= image_y + image_h)
				{
					if(interlace == 8 && (y - image_y) % 8 == 0) {
						interlace = 8;
						y = image_y + 4;
					}
					else if(interlace == 8  && (y - image_y) % 8 == 4) {
						interlace = 4;
						y = image_y + 2;
					}
					else if(interlace == 4) {
						interlace = 2;
						y = image_y + 1;
					}
				}
			}
			px = &bmp[(image_h-y-1)*3*image_w];
		}
	}
}


////////////////////////////////////////////////////////////////////////////
// Nacte Gif soubor

BYTE *CGif::load_gif(char *filename)
{
	int width, height, depth;
	int old;

	if(!f.Open(filename, CFile::modeRead | CFile::typeBinary, NULL)) return NULL;

	i  = f_getc() << 16;
	i += f_getc() <<  8;
	i += f_getc();
	// Test, zda je opravdu GIF soubor 
	if(i != 0x474946) {
		f.Close();
		return NULL;
	}

	f.Seek(3, CFile::current); // preskoceni verze

	width = f_getw();
	height = f_getw();

	// buffer
	bmp = new BYTE [width * height * 3];
	if(bmp == NULL) {
		f.Close();
		return NULL;
	}
	ZeroMemory(bmp, sizeof(BYTE)* width * height * 3);

	i = f_getc();
	// globalni tabulka barev
	if(i & 128) 
		depth = (i & 7) + 1;
	else
		depth = 0;

	// preskoceni transparentni barvy
	f.Seek(2, CFile::current); 


	if(pal && depth) // nacteni palety
	{
		for(i = 0; i < (1 << depth); i ++)
		{
			pal[i].r = f_getc();
			pal[i].g = f_getc();
			pal[i].b = f_getc();
		}
	}
	else
		if(depth)
			f.Seek((1 << depth) * 3, CFile::current); 

	for(;;)
	{
		i = f_getc();
		switch(i)
		{
			case 0x2C: // Popis obrazku
				image_x = f_getw();
				image_y = f_getw(); // rozmery obrazku
				image_w = f_getw();
				image_h = f_getw();

				px = &bmp[(image_h-1)*3*image_w];

				i = f_getc();
				if(i & 64)
					interlace = 8;
				else
					interlace = 1;

				if(i & 128)
				{
					depth = (i & 7) + 1;
					if(pal)
					{
						for(i = 0; i < (1 << depth); i ++)
						{
							pal[i].r = f_getc() / 4;
							pal[i].g = f_getc() / 4;
							pal[i].b = f_getc() / 4;
						}
					}
					else
						f.Seek((1 << depth) * 3, CFile::current);
				}

				// zacatek lzw dekomprese
				bit_size = f_getc();
				cc = 1 << bit_size;

				// inicializace string tablu
				for(i = 0; i < cc; i ++)
				{
					str[i].base = -1;
					str[i].newch = i;
					str[i].length = 1;
				}

				// inicializace promenych
				bit_pos = 0;
				data_len = f_getc(); data_pos = 0;
				entire = f_getc(); data_pos ++;
				string_length = 0; x = image_x; y = image_y;

				// zacatek kodu
				clear_table();
				get_code();
				if(code == cc)
					get_code();
				get_string(code);
				output_string();
				old = code;

				while(TRUE)
				{
					get_code();

					if(code == cc)
					{
						clear_table();
						get_code();
						get_string(code);
						output_string();
						old = code;
					}
					else if(code == cc + 1)
					{
						break;
					}
					else if(code < empty_string)
					{
						get_string(code);
						output_string();

						if(bit_overflow == 0) {
							str[empty_string].base = old;
							str[empty_string].newch = string[0];
							str[empty_string].length = str[old].length + 1;
							empty_string ++;
							if(empty_string == (1 << curr_bit_size))
								curr_bit_size ++;
							if(curr_bit_size == 13) {
								curr_bit_size = 12;
								bit_overflow = 1;
							}
						}

						old = code;
					}
					else
					{
						get_string(old);
						string[str[old].length] = string[0];
						string_length ++;

						if(bit_overflow == 0) {
							str[empty_string].base = old;
							str[empty_string].newch = string[0];
							str[empty_string].length = str[old].length + 1;
							empty_string ++;
							if(empty_string == (1 << curr_bit_size))
								curr_bit_size ++;
							if(curr_bit_size == 13) {
								curr_bit_size = 12;
								bit_overflow = 1;
							}
						}

						output_string();
						old = code;
					}
				}
				break;
			case 0x21: // rozsirujici casti - preskakujeme je
				i = f_getc();
				if(i == 0xF9)
				{
					// preskoceni velikosti ( == 4) 
					f.Seek(1, CFile::current);
					i = f_getc();
					if(i & 1)
					{
						f.Seek(2, CFile::current);
						f_getc();
					}
					else
						f.Seek(3, CFile::current);				
				}
				i = f_getc();
				// preskocnei bloku
				while(i) 
				{
					f.Seek(i, CFile::current);
					i = f_getc();
				}
				break;
			// Trailer - konec dat
			case 0x3B: 
				f.Close();
				return bmp;
		}
	}

	// jen pro jistotu
	return NULL;
}

////////////////////////////////////////////////////////////////////////////
// Nacte ze souboru byte

unsigned char CGif::f_getc()
{
	unsigned char c;
	f.Read(&c, sizeof(char));
	return c;
}

////////////////////////////////////////////////////////////////////////////
// Nacte ze souboru word

int CGif::f_getw()
{
	WORD w;
	f.Read(&w, sizeof(WORD));
	return w;
}
