//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// MainFrm.cpp : implementation of the CMainFrame class
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "BlueEye.h"
#include "MainFrm.h"
#include "SData.h"
#include "Settings.h"
#include "ImgID.h"
#include "Properties.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

////////////////////////////////////////////////////////////////////////////
// Mapa zprav

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FULLSCREEN, OnFullscreen)
	ON_WM_ERASEBKGND()
	ON_WM_SIZING()
	ON_WM_SIZE()
	ON_COMMAND(ID_IMGNEXT, OnImgnext)
	ON_COMMAND(ID_IMGPREV, OnImgprev)
	ON_WM_CHAR()
	ON_WM_MOUSEWHEEL()
	ON_COMMAND(ID_IMGRAND, OnImgrand)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_PAINT()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_ZOOM_FIT, OnZoomFit)
	ON_COMMAND(ID_CHANGE_DIR, OnChangeDir)
	ON_COMMAND(ID_SLIDESHOW, OnSlideshow)
	ON_COMMAND(ID_RELOAD, OnReload)
	ON_WM_TIMER()
	ON_COMMAND(ID_SETTINGS, OnSettings)
	ON_COMMAND(ID_IMGID, OnImgid)
	ON_UPDATE_COMMAND_UI(ID_SLIDESHOW, OnUpdate)
	ON_COMMAND(ID_ZOOM_100, OnZoom100)
	ON_COMMAND(ID_ZOOM_IN, OnZoomIn)
	ON_COMMAND(ID_ZOOM_OUT, OnZoomOut)
	ON_COMMAND(ID_PROPERY, OnPropery)
	ON_UPDATE_COMMAND_UI(ID_ZOOM_FIT, OnUpdate)
	ON_COMMAND(ID_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// indikatory statusbaru
static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	IDS_ID,
	IDS_FILE,
	IDS_FILESIZE,
	IDS_SIZE,
	IDS_ZOOM,
/*	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,*/
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_fullscreen = false;
	m_siztype    = 0;

	m_timer      = -1;

}

CMainFrame::~CMainFrame()
{
}

////////////////////////////////////////////////////////////////////////////
// Vytvori okno s toolbare, statusbarem a menu

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

// ToolBar
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

// StatusBar
	if (!m_wndStatusBar.CreateEx(this, SBT_TOOLTIPS) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndStatusBar.GetStatusBarCtrl().SetTipText(1, "Index aktuln zobrazovan bitmpay");
	m_wndStatusBar.GetStatusBarCtrl().SetTipText(2, "Jmno souboru bitmpay");
	m_wndStatusBar.GetStatusBarCtrl().SetTipText(3, "Velikost souboru bitmpay");
	m_wndStatusBar.GetStatusBarCtrl().SetTipText(4, "Velikost bitmpay");
	m_wndStatusBar.GetStatusBarCtrl().SetTipText(5, "Velikost zvten");

// Menu
	m_Menu.LoadMenu(IDR_MAINFRAME);
	SetMenu(&m_Menu);

// Ikonka
	m_Icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(m_Icon, TRUE);
	SetIcon(m_Icon, FALSE);

// Data
	doc.Create();

	return 0;
}

////////////////////////////////////////////////////////////////////////////
// Uprava stylu okna pred jeho vytvorenim

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

////////////////////////////////////////////////////////////////////////////
// Prepne do fullscreenu

void CMainFrame::OnFullscreen() 
{
	if (m_fullscreen == false) {
		ModifyStyle(WS_BORDER | WS_CAPTION | WS_THICKFRAME, WS_POPUP | WS_SYSMENU);
		ModifyStyleEx(WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE | WS_EX_STATICEDGE, WS_EX_TOPMOST);

		SetMenu(NULL);

		GetWindowRect(&m_winRect);

	   m_vToolBar = m_wndToolBar.IsWindowVisible();
	   m_vStatusBar = m_wndStatusBar.IsWindowVisible();

		m_wndToolBar.ShowWindow(FALSE);
		m_wndStatusBar.ShowWindow(FALSE);


		SetWindowPos(&wndTopMost, 0, 0, ::GetSystemMetrics(SM_CXSCREEN), ::GetSystemMetrics(SM_CYSCREEN), SWP_SHOWWINDOW);

		m_fullscreen = true;
	}
	else {

		SetMenu(&m_Menu);
		ModifyStyle(0, WS_BORDER | WS_CAPTION | WS_THICKFRAME);
		ModifyStyleEx(WS_EX_TOPMOST, WS_EX_WINDOWEDGE);

		m_wndToolBar.ShowWindow(m_vToolBar);
		m_wndStatusBar.ShowWindow(m_vStatusBar);

		SetWindowPos(&wndTop, m_winRect.left, m_winRect.top, m_winRect.Width(), m_winRect.Height(), SWP_SHOWWINDOW);

		m_fullscreen = false;
	}
}

////////////////////////////////////////////////////////////////////////////
// Maze pozadi okna. V nasem pripade vsak ne - zabranuje to blikani

BOOL CMainFrame::OnEraseBkgnd(CDC* pDC) 
{
	return CFrameWnd::OnEraseBkgnd(pDC);
}

////////////////////////////////////////////////////////////////////////////
// Reaguje na meneni velikosti okna - prekresleni, aby zustaval obrazek centrovany

void CMainFrame::OnSizing(UINT fwSide, LPRECT pRect) 
{
	CFrameWnd::OnSizing(fwSide, pRect);
	
	Invalidate(FALSE);
}

////////////////////////////////////////////////////////////////////////////
// Reaguje na zmenu velikosti okna - prekresleni, aby zustaval obrazek centrovany

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);

	Invalidate(FALSE);
}

////////////////////////////////////////////////////////////////////////////
// Ruseni okna

BOOL CMainFrame::DestroyWindow() 
{

	doc.Destroy();

	return CFrameWnd::DestroyWindow();
}

////////////////////////////////////////////////////////////////////////////
// Posun na dalsi obrazek

void CMainFrame::OnImgnext() 
{
	doc.LoadNextBitmap();

	// aby to hned neposkocilo pri uzivani spolu se slideshow
	OnSlideshow();
	OnSlideshow();

	Invalidate();
}

////////////////////////////////////////////////////////////////////////////
// Posun na predchozi obrazek

void CMainFrame::OnImgprev() 
{
	doc.LoadPrevBitmap();

	// aby to hned neposkocilo pri uzivani spolu se slideshow
	OnSlideshow();
	OnSlideshow();

	Invalidate();
}

////////////////////////////////////////////////////////////////////////////
// Reakce na vstup klavesnice

void CMainFrame::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == 32) {
		doc.LoadNextBitmap();
		Invalidate();
	}
	if (nChar == 8) {
		doc.LoadPrevBitmap();
		Invalidate();
	}
	
	CFrameWnd::OnChar(nChar, nRepCnt, nFlags);
}

////////////////////////////////////////////////////////////////////////////
// Obsluha kolecka mysi

BOOL CMainFrame::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	if (GetCapture() == this) return CFrameWnd::OnMouseWheel(nFlags, zDelta, pt);


	// je-li kolecko zmacknute - vezme se nahodny obrazek
	if (MK_MBUTTON & nFlags) OnImgrand();
	else {
		if (zDelta > 0) OnImgprev();
		if (zDelta < 0) OnImgnext();
	}
	
	return CFrameWnd::OnMouseWheel(nFlags, zDelta, pt);
}

////////////////////////////////////////////////////////////////////////////
// Posun na nahodny obrazek

void CMainFrame::OnImgrand() 
{
	doc.LoadRandBitmap();

	// aby to hned neposkocilo pri uzivani spolu se slideshow
	OnSlideshow();
	OnSlideshow();

	Invalidate();
}

////////////////////////////////////////////////////////////////////////////
// Obsluha stisku leveho knofliku mysi

void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect wrect;
	wrect = GetClientArea();
	if (wrect.Height() < doc.m_bRect.Height()*doc.m_sizing ||
		 wrect.Width()  < doc.m_bRect.Width()*doc.m_sizing) SetCapture();

	
	CFrameWnd::OnLButtonDown(nFlags, point);
}

////////////////////////////////////////////////////////////////////////////
// Obsluha uvolneni leveho knofliku mysi

void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseCapture();
	
	CFrameWnd::OnLButtonUp(nFlags, point);
}

////////////////////////////////////////////////////////////////////////////
// Obsluha posunuti kurzoru mysi

void CMainFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (GetCapture() == this)
	{
		doc.m_offset.cx -= m_mouselast.x - point.x;
		doc.m_offset.cy -= m_mouselast.y - point.y;
		Invalidate(FALSE);
	}
	
	m_mouselast = point;

	CFrameWnd::OnMouseMove(nFlags, point);
}

////////////////////////////////////////////////////////////////////////////
// Obsluha double-clicku leveho mysitka

void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	OnFullscreen();
	
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}

////////////////////////////////////////////////////////////////////////////
// Obsluha pozadavku na prekresleni okna

void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	double sz = doc.m_sizing;

	CRect wrect, brect, vrect;
	wrect = GetClientArea();

	// zoom to fit
	if (m_siztype == 1) {
		if ((double)wrect.Width()/(double)doc.m_bRect.Width() < (double)wrect.Height()/(double)doc.m_bRect.Height()) sz = (double)wrect.Width()/(double)doc.m_bRect.Width();
		else sz = (double)wrect.Height()/(double)doc.m_bRect.Height();
		doc.m_sizing = sz;
	}


	// Upraveni offsetu bitmapy
	if (wrect.Height() >= doc.m_bRect.Height()*sz) doc.m_offset.cy = 0;
	else {
		if (doc.m_offset.cy < (wrect.Height() - doc.m_bRect.Height()*sz)/2) doc.m_offset.cy =  (wrect.Height() - doc.m_bRect.Height()*sz)/2;
		if (doc.m_offset.cy > (doc.m_bRect.Height()*sz - wrect.Height())/2) doc.m_offset.cy = -(wrect.Height() - doc.m_bRect.Height()*sz)/2;
	}

	if (wrect.Width() >= doc.m_bRect.Width()*sz) doc.m_offset.cx = 0;
	else {
		if (doc.m_offset.cx < (wrect.Width() - doc.m_bRect.Width()*sz)/2) doc.m_offset.cx =  (wrect.Width() - doc.m_bRect.Width()*sz)/2;
		if (doc.m_offset.cx > (doc.m_bRect.Width()*sz - wrect.Width())/2) doc.m_offset.cx = -(wrect.Width() - doc.m_bRect.Width()*sz)/2;
	}

	// rect obrazku bitmapy
	brect.SetRect(wrect.Width()/2 - doc.m_bRect.Width()*sz/2 + doc.m_offset.cx, wrect.top + wrect.Height()/2 - doc.m_bRect.Height()*sz/2 + doc.m_offset.cy,
	              wrect.Width()/2 + doc.m_bRect.Width()*sz/2 + doc.m_offset.cx, wrect.top + wrect.Height()/2 + doc.m_bRect.Height()*sz/2 + doc.m_offset.cy);


	CDC cdc;
	cdc.CreateCompatibleDC(&dc);
	CBitmap *p_cdc = cdc.SelectObject(&doc.m_bBmp);

	// cerna rabva okolo bitmapy - dela se kazda strana zvlast, aby se zamezilo blikani
	// horni
	if (brect.top > wrect.top)
		dc.FillSolidRect(0, wrect.top, wrect.Width(), brect.top - wrect.top, 0);
	/// dolni 
	if (brect.bottom < wrect.bottom)
		dc.FillSolidRect(0, brect.bottom, wrect.Width(), wrect.bottom - brect.bottom, 0);
	// leva 
	if (brect.left > wrect.left)
		dc.FillSolidRect(wrect.left, wrect.top, brect.left - wrect.left, wrect.Height(), 0);
	// prava
	if (brect.right < wrect.right)
		dc.FillSolidRect(brect.right, wrect.top, wrect.right - brect.right, wrect.Height(), 0);

	
	// obdelnik bitmapy, ktery se bude kopirovat
	CPoint lt;
	if (brect.left > wrect.left) {
		vrect.left = brect.left;
		lt.x = 0;
	}
	else {
		vrect.left = wrect.left;
		lt.x = (wrect.left-brect.left)/sz;
	}
	if (brect.right < wrect.right) vrect.right = brect.right;
	else vrect.right = wrect.right;
	if (brect.top > wrect.top) {
		vrect.top = brect.top;
		lt.y = 0;
	}
	else {
		vrect.top = wrect.top;
		lt.y = (wrect.top-brect.top)/sz;
	}
	if (brect.bottom < wrect.bottom) vrect.bottom = brect.bottom;
	else vrect.bottom = wrect.bottom;

	// vlastni kopie
	dc.StretchBlt(vrect.left, vrect.top, vrect.Width(), vrect.Height(), &cdc, 
		           lt.x, lt.y, vrect.Width()/sz, vrect.Height()/sz, SRCCOPY);
	
	// uklid
	cdc.SelectObject(p_cdc);


	// aktualizace okna
	UpdateStatusBar();
}

////////////////////////////////////////////////////////////////////////////
// Obsluha praveho mysitka - vysune se pop-up menu

void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	POINT pt;
	GetCursorPos(&pt);

	CMenu m;
	m.LoadMenu(IDM_POPUP);
	m.GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON|TPM_LEFTALIGN, pt.x, pt.y, AfxGetApp()->m_pMainWnd);
	
	CFrameWnd::OnRButtonDown(nFlags, point);
}

////////////////////////////////////////////////////////////////////////////
// Vrati Rect okna, kam se muze kreslit

CRect CMainFrame::GetClientArea()
{
	CRect rect;
	GetClientRect(&rect);

	if (m_wndToolBar.IsWindowVisible())
	{
		CSize sz = m_wndToolBar.CalcFixedLayout(0, 1);
		rect.top += sz.cy;
	}
	if (m_wndStatusBar.IsWindowVisible())
	{
		CSize sz = m_wndStatusBar.CalcFixedLayout(0, 1);
		rect.bottom -= sz.cy;
	}
	return rect;
}

////////////////////////////////////////////////////////////////////////////
// Zapne zoom poodle okna

void CMainFrame::OnZoomFit() 
{
	if (m_siztype == 0) m_siztype = 1;
	else m_siztype = 0;
	Invalidate();
	
}

////////////////////////////////////////////////////////////////////////////
// Zmeni adresar

void CMainFrame::OnChangeDir() 
{
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Obrzky |*.bmp;*.jpg|Vechny soubory (*.*)|*.*||");
	
	if (dlg.DoModal() == IDOK) {
		doc.LoadDirFile(dlg.m_ofn.lpstrFile);
		Invalidate();
	}


}

////////////////////////////////////////////////////////////////////////////
// Zapne/vypne Slide-show

void CMainFrame::OnSlideshow() 
{
	if (m_timer == -1) {
		SetTimer(0, doc.m_slidet, NULL);
		m_timer = 0;
	}
	else {
		KillTimer(0);
		m_timer = -1;
	}
}

////////////////////////////////////////////////////////////////////////////
// Zpusobi reload aktualniho obrazku

void CMainFrame::OnReload() 
{
	doc.ReloadBitmap();
	Invalidate();
}

////////////////////////////////////////////////////////////////////////////
// Obsluha casovace - uziva se pri slide-show

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	if (doc.m_slider == false)
		doc.LoadNextBitmap();
	else
		doc.LoadRandBitmap();
	Invalidate();

	
	CFrameWnd::OnTimer(nIDEvent);
}

////////////////////////////////////////////////////////////////////////////
// Zavola dialog nastaveni

void CMainFrame::OnSettings() 
{
	CSettings dlg;
	dlg.DoModal();

	OnSlideshow();
	OnSlideshow();
}

////////////////////////////////////////////////////////////////////////////
// Prejde na obrazek podle ID

void CMainFrame::OnImgid() 
{
	if (doc.m_Dir.GetCount() != 0) {
		CImgID dlg;
		if (dlg.DoModal() == IDOK) {
			doc.LoadIndexBmp(dlg.m_id-1);
			Invalidate();
		}
	}
}

////////////////////////////////////////////////////////////////////////////
// Aktualizace rozhrani

void CMainFrame::OnUpdate(CCmdUI* pCmdUI) 
{
	if (m_timer != -1)
		m_wndToolBar.GetToolBarCtrl().PressButton(ID_SLIDESHOW, TRUE);
	else
		m_wndToolBar.GetToolBarCtrl().PressButton(ID_SLIDESHOW, FALSE);

	if (m_siztype == 1)
		m_wndToolBar.GetToolBarCtrl().PressButton(ID_ZOOM_FIT, TRUE);
	else
		m_wndToolBar.GetToolBarCtrl().PressButton(ID_ZOOM_FIT, FALSE);
}

////////////////////////////////////////////////////////////////////////////
// Nastavi zoom na 100%

void CMainFrame::OnZoom100() 
{
	doc.m_sizing = 1;
	m_siztype = 0;
	Invalidate();
}

////////////////////////////////////////////////////////////////////////////
// 2 X priblizi

void CMainFrame::OnZoomIn() 
{
	if (doc.m_sizing*2 <= 64) {
		doc.m_sizing *= 2;
		m_siztype = 0;
		Invalidate();
	}
}

////////////////////////////////////////////////////////////////////////////
// 2 X oddali

void CMainFrame::OnZoomOut() 
{
	if (doc.m_sizing / 2 > 0.01) {
		doc.m_sizing /= 2;
		m_siztype = 0;
		Invalidate();
	}
}

////////////////////////////////////////////////////////////////////////////
// Aktualizuje statusbar

void CMainFrame::UpdateStatusBar()
{
// nadpis okna
	CString s, s2;
	s.Format("(%d/%d)", doc.m_loadedc+1, doc.m_loadedt);
	GetWindowText(s2);
	if (s2 != doc.m_bLoaded+s)
		SetWindowText(doc.m_bLoaded+s);


//IDS_ID

	// ID
	s.Format("%d/%d",doc.m_loadedc+1, doc.m_loadedt);
	m_wndStatusBar.SetPaneText(1, s);

	// nazev
	m_wndStatusBar.SetPaneText(2, doc.m_actual.name);

	// velikost
	m_wndStatusBar.SetPaneText(3, doc.m_actual.size);

	// rozmery
	s.Format("%d*%d",doc.m_bRect.Width(), doc.m_bRect.Height());
	m_wndStatusBar.SetPaneText(4, s);

	// lupa
	s.Format("%d%%",(int)(doc.m_sizing*100.0));
	m_wndStatusBar.SetPaneText(5, s);
}

////////////////////////////////////////////////////////////////////////////
// Zobrazi vlastnosti

void CMainFrame::OnPropery() 
{
	CProperties dlg;
	dlg.DoModal();
}

////////////////////////////////////////////////////////////////////////////
// Smaze aktualni soubor

void CMainFrame::OnDelete() 
{
	doc.DeleteActual();
	Invalidate();
}
