//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__1356CC01_4815_4514_9D49_DFBDF2C8D336__INCLUDED_)
#define AFX_MAINFRM_H__1356CC01_4815_4514_9D49_DFBDF2C8D336__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();           // konstruktor
	virtual ~CMainFrame();  // destruktor

protected: 
	DECLARE_DYNAMIC(CMainFrame)

	int      m_siztype;   // 0 == normal, 1 == zoom to fit
	CPoint   m_mouselast; // posledni pozice kurzory mysi
	int      m_timer;     // cislo timeru;

// Operations
public:

// Overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	void UpdateStatusBar(); // aktualizuje texty ve statusbaru
	CRect GetClientArea();  // vrati rect casti okna na zobrazovani bitmapy

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  
	// control bar embedded members
	CStatusBar   m_wndStatusBar; // statusbar
	CToolBar     m_wndToolBar;   // toolbar
	CMenu        m_Menu;         // menu

	CRect       m_winRect; // rect okna na zobrazovani bitmapy
	HICON       m_Icon;    // ikona aplikace

	BOOL        m_vToolBar;    // zda je viditelny toolbar 
	BOOL        m_vStatusBar;  // zda je viditelny statusbar
	bool			m_fullscreen;  // zda je aplikace ve fullscreenu

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFullscreen();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnImgnext();
	afx_msg void OnImgprev();
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnImgrand();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnZoomFit();
	afx_msg void OnChangeDir();
	afx_msg void OnSlideshow();
	afx_msg void OnReload();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSettings();
	afx_msg void OnImgid();
	afx_msg void OnUpdate(CCmdUI* pCmdUI);
	afx_msg void OnZoom100();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnPropery();
	afx_msg void OnDelete();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__1356CC01_4815_4514_9D49_DFBDF2C8D336__INCLUDED_)
