//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// Pcx.h: interface for the CPcx class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PCX_H__538BEC40_1374_11D4_8F75_CFFE2D0765D6__INCLUDED_)
#define AFX_PCX_H__538BEC40_1374_11D4_8F75_CFFE2D0765D6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct                  // ofset   Popis            
{
    BYTE   Id;                  //  00h     ID  == 0xA (10)     
    BYTE   Version;             //  01h     cislo verze                
    BYTE   Encoding;            //  02h     zpusob kodovani - musi bit 1 == RLE        
    BYTE   BitsPerPixel;        //  03h     pocet bitu na pixel
    WORD   Left;                //  04h     levy horni roh   
    WORD   Top;                 //  06h     levy horni roh
    WORD   Right;               //  08h     pravy dolni roh    
    WORD   Bottom;              //  0Ah     pravy dolni roh         
    WORD   Hdpi;                //  0Ch     Horizontalni rozliseni  
    WORD   Vdpi;                //  0Eh     Vertikalni rozliseni    
    BYTE   EgaPalette[48];      //  10h     16-barev EGA Palety
    BYTE   Reserved;            //  40h     rezervivano               
    BYTE   ColorPlanes;         //  41h     pocet obrazovych rovin
    WORD   BytesPerLine;        //  42h     pocet bajtu na radek
    WORD   PaletteInfo;         //  44h     zpusob interpretace palety: 1 == color/mono; 2 == odstiny sedi 
    BYTE   Reser[58];           //  46h     nepouzito               
} PCX_HEADER;


class CPcx  
{
public:
	static BYTE* LoadPCX(CString filename, int *w, int *h);
	static CBitmap * ReadPCX(CDC *dc, CString filename, CRect *rect);
	CPcx();
	virtual ~CPcx();
};

#endif // !defined(AFX_PCX_H__538BEC40_1374_11D4_8F75_CFFE2D0765D6__INCLUDED_)
