//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// SData.cpp: implementation of the SData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "blueeye.h"
#include "SData.h"
#include "IO.H"

#include "jpg.h"
#include "pcx.h"
#include "gif.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

SData doc;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SData::SData()
{
	m_offset.cx  = 0;
	m_offset.cy  = 0;
	m_sizing = 1;
}

SData::~SData()
{
	SaveProfile();
}


////////////////////////////////////////////////////////////////////////////
// Nacte bitmapu

void SData::LoadBitmap(st_file s)
{

	m_bBmp.DeleteObject();

	if (!s.name.IsEmpty())
	{
		SetCurrentDirectory(s.dir);

		if (s.ext == "BMP") BLoadBMP(s.name);
		if (s.ext == "JPG") BLoadJPG(s.name);
		if (s.ext == "PCX" && m_all_pcx) BLoadPCX(s.name);
		if (s.ext == "GIF" && m_all_gif) BLoadGIF(s.name);

		SetCurrentDirectory(m_CurrDirr);
	}

	m_bLoaded = s.dir + "\\" + s.name;
	m_actual = s;

	if (m_bBmp.m_hObject != NULL) {
		BITMAP bmp;
		m_bBmp.GetBitmap(&bmp);
		m_bRect.SetRect(0, 0, bmp.bmWidth, bmp.bmHeight);
	}
	else
		m_bRect.SetRectEmpty();
}

////////////////////////////////////////////////////////////////////////////
// Inicializace

void SData::Create()
{

	AddDirFiles();
}

////////////////////////////////////////////////////////////////////////////
// Zruseni

void SData::Destroy()
{
	m_bBmp.DeleteObject();
}

////////////////////////////////////////////////////////////////////////////
// Zmena adresare

void SData::ChangeDir(CString s)
{
	char c[256];
	GetCurrentDirectory(256, c);
	CString nd;
	nd = c;
	nd += '\\';
	nd += s;
	SetCurrentDirectory(nd);

	GetCurrentDirectory(256, c);
	m_CurrDirr = c;
}

////////////////////////////////////////////////////////////////////////////
// Prida soubory z aktualniho adresare

void SData::AddDirFiles()
{
	m_Dir.RemoveAll();

	char c[256];
	GetCurrentDirectory(256, c);
	CString nd;
	nd = c;

	AddDir(nd, m_subdirload);

	ChangeDir(c);

	m_loadedc = -1;
	m_loadedt = m_Dir.GetCount();

	LoadFirstBitmap();
}

////////////////////////////////////////////////////////////////////////////
// Nacte dalsi bitmapu

void SData::LoadNextBitmap()
{
	LoadIndexBmp(m_loadedc + 1);
}

////////////////////////////////////////////////////////////////////////////
// Nacte predchozi bitmapu

void SData::LoadPrevBitmap()
{
	LoadIndexBmp(m_loadedc - 1);
}

////////////////////////////////////////////////////////////////////////////
// Zda je koncovka podporovana

BOOL SData::IsExtSupported(CString ext)
{
	ext.MakeUpper();
	if (ext == "BMP") return TRUE;
	if (ext == "JPG") return TRUE;
	if (ext == "PCX" && m_all_pcx) return TRUE;
	if (ext == "GIF" && m_all_gif) return TRUE;

	return FALSE;
}

////////////////////////////////////////////////////////////////////////////
// Prida soubory zadaneho adresare

void SData::AddDir(CString dir, bool subfolders)
{

	CString nd;

	CFileFind ff;
	st_file dat;

	BOOL bWorking = ff.FindFile("*.*");
   while (bWorking)
   {
      bWorking = ff.FindNextFile();
      dat.name = ff.GetFileName();
		if (ff.IsDirectory()) {
			if (subfolders && dat.name != "." && dat.name != "..") {
				nd = dir;
				nd += '\\';
				nd += dat.name;
				SetCurrentDirectory(nd);
				AddDir(nd, true);
				SetCurrentDirectory(dir);
			}
		}
		else {
			CString ext = ff.GetFileName();
			ext.Replace(ff.GetFileTitle(), "");
			ext.Remove('.');
			ext.MakeUpper();
			if (IsExtSupported(ext)) {
				dat.dir = dir;
				dat.ext = ext;
				if (ff.GetLength() < 1000000)
					if (ff.GetLength() / 1000 == 0) dat.size = " < 1KB";
					else dat.size.Format("%dKB", ff.GetLength() / 1000);
				else
					dat.size.Format("%dMB", ff.GetLength() / 1000000);
				m_Dir.AddTail(dat);
			}
		}

   }
}

////////////////////////////////////////////////////////////////////////////
// Nacte prvni bitmapu

void SData::LoadFirstBitmap()
{
	LoadIndexBmp(0);
}

////////////////////////////////////////////////////////////////////////////
// Nacte BMP soubor

void SData::BLoadBMP(CString file)
{
	BITMAP bm;

	HBITMAP hbm = (HBITMAP)LoadImage(NULL, file, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
   GetObject(hbm, sizeof(bm), &bm);      // get size of bitmap

	CDC *dc = AfxGetApp()->m_pMainWnd->GetDC();
	m_bBmp.CreateCompatibleBitmap(dc, bm.bmWidth, bm.bmHeight);

	CBitmap *tmp;
	tmp = CBitmap::FromHandle(hbm);

	CDC dc1, dc2;
	dc1.CreateCompatibleDC(dc);
	dc2.CreateCompatibleDC(dc);
	CBitmap *p_dc1 = dc1.SelectObject(&m_bBmp);
	CBitmap *p_dc2 = dc2.SelectObject(tmp);

	dc1.BitBlt(0, 0, bm.bmWidth, bm.bmHeight, &dc2, 0, 0, SRCCOPY);

	dc1.SelectObject(p_dc1);
	dc2.SelectObject(p_dc2);
	
   DeleteObject(hbm);		

	AfxGetApp()->m_pMainWnd->ReleaseDC(dc);
}

////////////////////////////////////////////////////////////////////////////
// Nacte JPG soubor

void SData::BLoadJPG(CString file)
{
	UINT				 height;
	UINT				 width;
	BYTE				 *dataBuf;
	PBITMAPINFO			 bmpi;
	INT				 Bits;


	// Read JPEGData into a buffer...
	char c[256];
	strcpy(c, file);
	dataBuf = CJPEG::LoadJPEG( c, &width, &height, &Bits );
	if( dataBuf == NULL ) return;

	// Transfer Variables...
	Bits = 24;
	INT lineWidth = width * 3;
    if(lineWidth & 0x003) lineWidth = (lineWidth | 3) + 1;

	// Init the Bitmapstruct...
   bmpi = (PBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD)));
	bmpi->bmiHeader.biSize				= sizeof(BITMAPINFOHEADER);
	bmpi->bmiHeader.biWidth				= width;
	bmpi->bmiHeader.biHeight			= height;
	bmpi->bmiHeader.biPlanes			= 1;
	bmpi->bmiHeader.biCompression       = BI_RGB; 
	bmpi->bmiHeader.biBitCount			= Bits;
	bmpi->bmiHeader.biSizeImage			= 0;
	bmpi->bmiHeader.biClrUsed			= 0; 
	bmpi->bmiHeader.biClrImportant		= 0; 


	CDC *dc = AfxGetApp()->m_pMainWnd->GetDC();
	m_bBmp.CreateCompatibleBitmap(dc, width, height);

	CDC cdc; cdc.CreateCompatibleDC(dc); 
	CBitmap *p_cdc = cdc.SelectObject(&m_bBmp);
	// Blt the stuff now...
	StretchDIBits( cdc, 0, 0, width, height, 0, 0, width, height, dataBuf, bmpi, 0, SRCCOPY );

	// free the stuff...
	delete dataBuf;
	LocalFree((PBITMAPINFO)bmpi);

	 cdc.SelectObject(p_cdc);

	AfxGetApp()->m_pMainWnd->ReleaseDC(dc);

}

////////////////////////////////////////////////////////////////////////////
// Nacte PCX soubor

void SData::BLoadPCX(CString file)
{
/*	CDC *dc = AfxGetApp()->m_pMainWnd->GetDC();

	CBitmap *tmp = CPcx::ReadPCX(dc, file, &m_bRect);
	if (tmp == NULL) 
	{
		AfxGetApp()->m_pMainWnd->ReleaseDC(dc);
		return;
	}


	m_bBmp.CreateCompatibleBitmap(dc, m_bRect.Width(), m_bRect.Height());


	CDC dc1, dc2;
	dc1.CreateCompatibleDC(dc);
	dc2.CreateCompatibleDC(dc);
	CBitmap *p_dc1 = dc1.SelectObject(&m_bBmp);
	CBitmap *p_dc2 = dc2.SelectObject(tmp);

	dc1.BitBlt(0, 0, m_bRect.Width(), m_bRect.Height(), &dc2, 0, 0, SRCCOPY);

	dc1.SelectObject(p_dc1);
	dc2.SelectObject(p_dc2);
	
   tmp->DeleteObject();		
	delete tmp;
	
	AfxGetApp()->m_pMainWnd->ReleaseDC(dc);
*/
	int				 height;
	int				 width;
	BYTE				 *dataBuf;
	PBITMAPINFO		 bmpi;
	INT				 Bits;


	// Read JPEGData into a buffer...
	char c[256];
	strcpy(c, file);
	dataBuf = CPcx::LoadPCX( c, &width, &height);
	if( dataBuf == NULL ) return;

	// Transfer Variables...
	Bits = 24;
	INT lineWidth = width * 3;
    if(lineWidth & 0x003) lineWidth = (lineWidth | 3) + 1;

	// Init the Bitmapstruct...
   bmpi = (PBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD)));
	bmpi->bmiHeader.biSize				= sizeof(BITMAPINFOHEADER);
	bmpi->bmiHeader.biWidth				= width;
	bmpi->bmiHeader.biHeight			= height;
	bmpi->bmiHeader.biPlanes			= 1;
	bmpi->bmiHeader.biCompression       = BI_RGB; 
	bmpi->bmiHeader.biBitCount			= Bits;
	bmpi->bmiHeader.biSizeImage			= 0;
	bmpi->bmiHeader.biClrUsed			= 0; 
	bmpi->bmiHeader.biClrImportant		= 0; 


	CDC *dc = AfxGetApp()->m_pMainWnd->GetDC();
	m_bBmp.CreateCompatibleBitmap(dc, width, height);

	CDC cdc; cdc.CreateCompatibleDC(dc); 
	CBitmap *p_cdc = cdc.SelectObject(&m_bBmp);
	// Blt the stuff now...
	StretchDIBits( cdc, 0, 0, width, height, 0, 0, width, height, dataBuf, bmpi, 0, SRCCOPY );

	// free the stuff...
	delete dataBuf;
	LocalFree((PBITMAPINFO)bmpi);

	 cdc.SelectObject(p_cdc);

	AfxGetApp()->m_pMainWnd->ReleaseDC(dc);
}

////////////////////////////////////////////////////////////////////////////
// Nacte nahodnou bitmapu

void SData::LoadRandBitmap()
{
	if (doc.m_Dir.GetCount() != 0)
		LoadIndexBmp(rand()%doc.m_Dir.GetCount());
}

////////////////////////////////////////////////////////////////////////////
// Zrusi bitmapu

void SData::DestroyBMP()
{
	m_bBmp.DeleteObject();
}

////////////////////////////////////////////////////////////////////////////
// Nacte adresar a danou bitmapu

void SData::LoadDirFile(CString f)
{
	CString s;
	s = f;
	while (s[s.GetLength()-1] != '\\') s.Delete(s.GetLength()-1);

	ChangeDir(s);

	AddDirFiles();
}

////////////////////////////////////////////////////////////////////////////
// Nacte nastaveni

void SData::LoadProfile()
{
	m_slidet     = AfxGetApp()->GetProfileInt("Settings", "slidet", 4000);
	m_slider     = AfxGetApp()->GetProfileInt("Settings", "slider", 1);
	m_subdirload = AfxGetApp()->GetProfileInt("Settings", "subdirload", 1);
	m_repeat     = AfxGetApp()->GetProfileInt("Settings", "repeat", 0);
	m_all_gif    = AfxGetApp()->GetProfileInt("Settings", "all gif", 0);
	m_all_pcx    = AfxGetApp()->GetProfileInt("Settings", "all pcx", 0);
}

////////////////////////////////////////////////////////////////////////////
// Ulozi nastaveni

void SData::SaveProfile()
{
	AfxGetApp()->WriteProfileInt("Settings", "slidet", m_slidet);
	AfxGetApp()->WriteProfileInt("Settings", "slider", m_slider);
	AfxGetApp()->WriteProfileInt("Settings", "subdirload", m_subdirload);
	AfxGetApp()->WriteProfileInt("Settings", "repeat", m_repeat);
	AfxGetApp()->WriteProfileInt("Settings", "all gif", m_all_gif);
	AfxGetApp()->WriteProfileInt("Settings", "all pcx", m_all_pcx);
}

////////////////////////////////////////////////////////////////////////////
// Znovu nacte bitmapu

void SData::ReloadBitmap()
{
	POSITION pos = doc.m_Dir.FindIndex(m_loadedc);
	st_file f;

	if (pos) {
		f = doc.m_Dir.GetAt(pos);
		LoadBitmap(f);
	}
}

////////////////////////////////////////////////////////////////////////////
// Nacte bitmapu podle indexu

void SData::LoadIndexBmp(int index)
{
	if (m_loadedt == 0) return;
	if ((index >= m_loadedt || index < 0) && m_repeat == false) return;
	if (index >= m_loadedt) index = 0;
	if (index < 0) index = m_loadedt - 1;

	POSITION pos = doc.m_Dir.FindIndex(index);
	st_file f;

	if (pos) {
		f = doc.m_Dir.GetAt(pos);
		m_loadedc = index;
		LoadBitmap(f);
		m_sizing = 1; 
	}
}

////////////////////////////////////////////////////////////////////////////
// Smaze aktualni bitmapu

void SData::DeleteActual()
{
	if (AfxMessageBox("Opravdu chcete soubor smazat?", MB_YESNO) == IDYES) {
		DeleteFile(m_bLoaded);

		POSITION pos = doc.m_Dir.FindIndex(m_loadedc);
	
		if (pos) {
			doc.m_Dir.RemoveAt(pos);
			m_loadedt--;
			LoadIndexBmp(m_loadedc);
			m_sizing = 1; 
		}
	}
}

////////////////////////////////////////////////////////////////////////////
// Nacte Gif obrazek

void SData::BLoadGIF(CString file)
{
	int				 height;
	int				 width;
	BYTE				 *dataBuf;
	PBITMAPINFO		 bmpi;
	INT				 Bits;


	// Read JPEGData into a buffer...
	char c[256];
	strcpy(c, file);
	CGif gif;
	dataBuf = gif.load_gif(c);
	height = gif.image_h;
	width = gif.image_w;
	if( dataBuf == NULL ) return;

	// Transfer Variables...
	Bits = 24;
	INT lineWidth = width * 3;
    if(lineWidth & 0x003) lineWidth = (lineWidth | 3) + 1;

	// Init the Bitmapstruct...
   bmpi = (PBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + (256 * sizeof(RGBQUAD)));
	bmpi->bmiHeader.biSize				= sizeof(BITMAPINFOHEADER);
	bmpi->bmiHeader.biWidth				= width;
	bmpi->bmiHeader.biHeight			= height;
	bmpi->bmiHeader.biPlanes			= 1;
	bmpi->bmiHeader.biCompression    = BI_RGB ; 
	bmpi->bmiHeader.biBitCount			= Bits;
	bmpi->bmiHeader.biSizeImage		= 0;
	bmpi->bmiHeader.biClrUsed			= 0; 
	bmpi->bmiHeader.biClrImportant	= 0; 


	CDC *dc = AfxGetApp()->m_pMainWnd->GetDC();
	m_bBmp.CreateCompatibleBitmap(dc, width, height);

	CDC cdc; cdc.CreateCompatibleDC(dc); 
	CBitmap *p_cdc = cdc.SelectObject(&m_bBmp);
	// Blt the stuff now...
	StretchDIBits( cdc, 0, 0, width, height, 0, 0, width, height, dataBuf, bmpi, 0, SRCCOPY );

	// free the stuff...
	delete dataBuf;
	LocalFree((PBITMAPINFO)bmpi);

	 cdc.SelectObject(p_cdc);

	AfxGetApp()->m_pMainWnd->ReleaseDC(dc);
}
