//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// SData.h: interface for the SData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SDATA_H__DE20E8AC_A69B_4341_9640_B6A88F4FA0A7__INCLUDED_)
#define AFX_SDATA_H__DE20E8AC_A69B_4341_9640_B6A88F4FA0A7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct {
	CString name; // jmeno souboru
	CString dir;  // adresar, ve kterej soubor je
	CString size;
	CString ext;
} st_file;


class SData  
{
public:
// inicializace:
	SData();
	virtual ~SData();

	void LoadProfile();  // nacte nastaveni
	void SaveProfile();  // ulozi nastaveni

	void Create();  // inicializuje
	void Destroy(); // znici

// Nacitani bitmap:
	void ReloadBitmap();          // znovu nacte aktualni bitmapu
	void LoadPrevBitmap();        // nacte predchozi bitmapu
	void LoadNextBitmap();        // nacte nasledujici bitmpau
	void LoadIndexBmp(int index); // nacte bitmapu podle indexu
	void LoadFirstBitmap();       // nacte 1. bitmapu
	void LoadRandBitmap();        // nacte nahodnou bitmapu

// Prace s adresari
	void ChangeDir(CString s);                 // zmeni adresar a nacte v nem vsechny bitmapy
	void AddDirFiles();                        // prida v aktualnim adresari 
	void AddDir(CString dir, bool subfolders); // rekurzivni nacitani podadresaru
	BOOL IsExtSupported(CString ext);          // zda je koncovka podporovana
	void LoadDirFile(CString f);               // nacte soubor a s nim cely adresar

private:
// Interni nacitani
	void LoadBitmap(st_file s);
	void BLoadJPG(CString file);
	void BLoadPCX(CString file);
	void BLoadBMP(CString file);
	void DestroyBMP();


public:
	void BLoadGIF(CString file);
	void DeleteActual();
// Data:
	CList<st_file, st_file> m_Dir; // seznam obrazku
	bool        m_subdirload;      // zda se maji nacitat podadresare
	int         m_loadedt;         // nactenych celkem
	int         m_loadedc;         // aktualne nactena

	CBitmap     m_bBmp;      // Zobrazovana bitmapa
	st_file     m_actual;    // aktualne zobrazovana bitmapa
	CString     m_bLoaded;   // string zobrazene bitmapy
	CString     m_CurrDirr;  // aktualne nacteny adresar
	CRect       m_bRect;     // rect zobrazovane bitmapy
	CSize       m_offset;    // rect zobrazovane bitmapy v okne
	double      m_sizing;    // zvetseni

	int         m_slidet;     // slidesow timer
	bool        m_slider;     // zda na byt slideshow nahodna
	bool        m_repeat;     // zda se ma prohlizet cyklicky
	bool        m_all_pcx;    // povoleni pouzivani pcx souboru
	bool        m_all_gif;    // povoleni pouzivani gif souboru
};

extern SData doc;

#endif // !defined(AFX_SDATA_H__DE20E8AC_A69B_4341_9640_B6A88F4FA0A7__INCLUDED_)
