//////////////////////////////////////////////////////////////////////
//
// Project : BlueEye
//
// Autor : Bernard Lidicky
//
// Settings.cpp : implementation file
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "blueeye.h"
#include "Settings.h"
#include "SData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettings dialog


CSettings::CSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettings)
	m_slider = doc.m_slider;
	m_slidet = doc.m_slidet;
	m_subdirload = doc.m_subdirload;
	m_repeat = doc.m_repeat;
	m_all_gif = doc.m_all_gif;
	m_all_pcx = doc.m_all_pcx;
	//}}AFX_DATA_INIT
}


void CSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettings)
	DDX_Check(pDX, IDC_SLIDER, m_slider);
	DDX_Text(pDX, IDC_SLIDET, m_slidet);
	DDX_Check(pDX, IDC_SUBDIRLOAD, m_subdirload);
	DDX_Check(pDX, IDC_RELOAD, m_repeat);
	DDX_Check(pDX, IDC_ALL_GIF, m_all_gif);
	DDX_Check(pDX, IDC_ALL_PCX, m_all_pcx);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettings, CDialog)
	//{{AFX_MSG_MAP(CSettings)
	ON_BN_CLICKED(IDC_INTEGRATE, OnIntegrate)
	ON_BN_CLICKED(IDC_UNINTEGRATE, OnUnintegrate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettings message handlers

void CSettings::OnIntegrate() 
{
	CRegKey rkey;
	rkey.Create(HKEY_CLASSES_ROOT, "Directory\\shell\\BleuEye.Browse");
	rkey.SetValue("Projdi &v BlueEye");

	CString s = AfxGetApp()->m_pszHelpFilePath;
	while (s[s.GetLength()-1] != '.') s.Delete(s.GetLength()-1);
	s += "exe";
	CString rs;
	rs = "\"" + s + "\" \"%1\"";
	
	rkey.SetKeyValue("command", rs);
	rkey.Close();
}

void CSettings::OnOK() 
{
	UpdateData();
	doc.m_slider = m_slider;
	doc.m_slidet = m_slidet;
	doc.m_subdirload = m_subdirload;
	doc.m_repeat = m_repeat;
	doc.m_all_gif = m_all_gif;
	doc.m_all_pcx = m_all_pcx;
	
	CDialog::OnOK();
}

void CSettings::OnUnintegrate() 
{
	CRegKey rkey;
	rkey.Create(HKEY_CLASSES_ROOT, "Directory\\shell\\BleuEye.Browse");
	rkey.DeleteSubKey("command");
	rkey.Close();
	rkey.Create(HKEY_CLASSES_ROOT, "Directory\\shell");
	rkey.DeleteSubKey("BleuEye.Browse");
	rkey.Close();
}
